
        Device = 16F877A
        Xtal = 8

'--------------------------   --------------------
                                                                   
Config  DEBUG_OFF, WRT_OFF, CPD_OFF, LVP_OFF, BODEN_OFF, PWRTE_OFF, WDT_OFF, HS_OSC 


'  
		
Dim n  As Byte        '   
Dim t As Byte         '      
Dim Perem As Byte          '      
Dim Pusk As Perem.0       '   
Dim Napr As Perem.1       '   . - (1)  - (0)
Dim Konec As Perem.2     '   
Dim Pr_k As Bit      '    USART
Dim Per_k As Bit      '    
Dim A As Byte         '   
Dim Reg As Byte       '  
Dim U_a As Word       '   
Dim U1 As Word        '    
Dim U2 As Word        '     
Dim Tok_k As Byte     '     
Dim Duty As Byte       '      
Dim sek As Byte                           
Dim Duty_1 As Byte     '       

Dim TrTmr As Byte      '   (   )
'Dim Priem As Bit           '    

TRISC.5 = 0
TRISB.1 = 0

Symbol PrUART PIE1.5
Symbol PerUART PIE1.4

;--------------------------  USART -------------------------- 
Declare Hserial_Baud 9600 ;   ,  
'Declare Hserial_Baud 19200 ;   ,  
Declare Hserial_RCSTA = %10010000  ' Enable serial port and continuous receive 
Declare Hserial_TXSTA = %00100000  ' Enable transmit and asynchronous mode  
'Declare Hserial_SPBRG 6 ;   SPBRG   
Declare Hserial_Clear = On ;         

'  
Declare Adin_Res = 10 					' 12-bit ADC result required 
Declare Adin_Tad = 32_FOSC 					' RC OSC chosen 
Declare Adin_Stime = 50 				' Allow 50us sample time 
'   AN0 (PORTA.0)  AN1 (PORTA.1)  
TRISA = %000111         
'    PORTA.0  PORTA.1     
ADCON1 = %10000000       

Declare Create_Coff = On	    
		
'--------------------------------------
'  
'------------------------------------
OPTION_REG = %10010111        '   
        '        B0
        '    1- , 0-  F/4
        '
        '    /128
        '

On_Hardware_Interrupt GoTo  Prer

PORTB.1 = 0
PORTC.5 = 0
Reg = 0
Pr_k = 0
A = 0
U_a = 2
t = 0
sek = 0
Duty = 100
Duty_1 = 1
Pusk = 0
Napr = 0
TrTmr = 0
Konec = 0
INTCON.6 = 1      '   
PIE1.5 = 1        '     USART
 INTCON.7 = 1
GoTo Main

'*****************************
'   
'***************************
Prer:
Context Save 
If PIR1.5 = 1 Then                           
 Pr_k = 1
 PIE1.5 = 0        '     USART       
EndIf
If PIR1.4 = 1 And PIE1.4 = 1  Then                           
 'PORTC.5 = 0
 PIE1.4 = 0       
EndIf
If INTCON.5 = 1 And INTCON.2 = 1 Then
  Inc t
  If t = 32 Then
   Inc sek: t = 0 
  EndIf
  If t = 31 Or t = 15 Then
    Per_k = 1
  EndIf
 INTCON.2 = 0
EndIf
Context Restore                
Resume

'********************************************
'   
'  5 . 1-; 21-.-; 22-.-; 3-;
' 4-; 
'*****************************************

Main:
HPWM 1, 10, 1000           '     
DelayMS 50
PORTB.1 = 0    ' .  
If Pr_k = 1 Then
GoSub Rs232_in
EndIf
If Reg = 1 And Pusk = 1 Then GoTo Komp 
GoTo Main
'***********************************
'    
'***********************************
Komp:             '   
Konec = 1
GoSub RS232_out
U1 = Tok_k '* 2 
U2 = Tok_k /10
HPWM 2, 255, 2000          '  
INTCON.5 = 1
DelayMS 50
PORTB.1 = 1                ' .  
HPWM 1, U2, 1000        '      
Repeat
  If Pr_k = 1 Then GoSub Rs232_in
  GoSub Ism
  If Per_k = 1 Then GoSub RS232_out
Until Pusk = 0
Konec = 0
PORTB.1 = 0
HPWM 1, 10, 1000
HPWM 2, 0, 2000          '  
INTCON.5 = 0
GoSub RS232_out 
GoTo Main 

'*****************************
'    
'*****************************
Ism:
  U_a = ADIn 0                   '  
  U_a =  U_a * 10
  A = U_a / 47
 
 Return

'*****************************
'    
'*****************************
'  
Rs232_in:
DelayMS 1
HSerIn [Perem, Reg]
DelayMS 1
Pr_k = 0
PIE1.5 = 1
Return

'  
RS232_out: 
PORTC.5 = 1
DelayUS 500
HSerOut [A, Perem]
PIE1.4 = 1        '     USART
DelayMS 2
PORTC.5 = 0
Per_k = 0
PIE1.5 = 1
Return

